//
//      Copyright Timothy Evans 2014    timothy.evans@gsecraif.org
//
//      This file is part of gsecraif.
//
//      gsecraif is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 3 of the License, or
//      (at your option) any later version.
//
//      See gsecraif.cpp
//
// =====================================================================
//
// print help
//
// $Date$
// $Revision$
// =====================================================================
//
// Compile with g++
#include "print_help.h"

using namespace std;
void print_help(char *programmename)
{
    vector<string> options;
    //gcc version 4.5.2 (Ubuntu/Linaro 4.5.2-8ubuntu4) does not seem to work
    // { } initialization        
    options.push_back("-h, --help           Print help and exit");
    options.push_back("-V, --version        Print version and exit");
    options.push_back("-c, --combine        Combine files");
    options.push_back("-d, --debug=INT      Debug level N (Default is 0 - no output)");
    options.push_back("-n, --nfiles=INT     Number of component files (default is 3)");
    options.push_back("-p, --prefix=STRING  Set the file prfix (Default is split)");
    options.push_back("-r, --rotate=INT     Rotate N bits");
    options.push_back("-#, --hash           Print # characters");
    vector<string>::iterator option;
    const string purpose = "The utility gsecraif is a tool to split and recombine files in a secure manner.";
    const string usage = "Usage: gsecraif [OPTIONS]... [FILES]...";
    const string description = "Input is expected from standard-in, output is to standard-out.\nDefault action is to split standard-in in to a number of component files.\nNames may be given for the component files; if no names are given, a prefix is\nused followed by a three digit number starting with 000.";

    cout << programmename << "\n";
    cout << "\n";
    cout << description << "\n";
    cout << "\n";
    cout << usage << "\n";
    cout << "\n";

    for (option = options.begin(); option != options.end(); ++option) {
        cout << *option << "\n";
        }
}  // end of function
